%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Program written to see if we can
%reduce out negative innovations
%so that max operator holds as far
%as possible
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp(' ');
disp('Checking if the solution appears is the preferred one, i.e. we cannot fulfill the ZLB with');
disp('a smaller set of innovations that have a smaller norm than what we have already');
disp(' ');
%ActIndicator
%[Shocks ShockLoci]

normInit=norm(Shocks);
%[mean(Init) norm(Shocks)]
ActIndicatorInit=ActIndicator;

ActIndicatorT=ActIndicator;%trial indicator matrix
ShockInfMat = [Shocks ShockLoci];
%First, working on the FFR shocks
Sper = min(find(ActIndicator(:,1)==1));
Eper = max(find(ActIndicator(:,1)==1));
IndVecFFR=[Sper:1:Eper];
if isempty(IndVecFFR)==0;
    ShocksD = ShockInfMat(IndVecFFR-(Sper-1),:);
end;
if any(ShocksD(:,1)<0);
   IndVec=find(ShocksD(:,1)<0);
   i=1;
   SuccessInf = [];
   while length(IndVec)>=1 & i<=length(IndVec);
       ActIndicatorT(IndVec(i)+(Sper-1),1)=0;
       [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
       [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
       if min(min(simvar(:,[1 2])+4))<-1e-5;%things did not work out. stop
          SuccessInf = [SuccessInf;0];
          ActIndicatorT(IndVec(i)+(Sper-1),1)=1;
          if length(IndVec)>1;
             IndVec=IndVec(2:end);
          else;
             break
          end;
       else;%important, conjecture that other shocks do not flip sign if we can remove a negative shock, 
            %therefore, no need to verify that the other shocks have not flipped sign because we have removed a negative shock
          SuccessInf = [SuccessInf;1];
          i=i+1;
       end;
   end;  
   if mean(SuccessInf)==1;
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
      ActIndicator=ActIndicatorT;
      %disp('Success: We could remove all negative shocks for FFR');
   elseif any(SuccessInf==1);%Some negative shock could be removed
      ActIndicator=ActIndicatorT;
      [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicator(1:t,:),eqtype_,endog_);
      [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
      %disp('Partial success: We could remove at least one of the negative shocks for FFR');
   else; %disp('We could not remove any negative shocks for FFR');
   end;
   if norm(Shocks)>normInit;%do not use updated shocks if norm of shocks higher
      ActIndicator=ActIndicatorInit;
      [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicator(1:t,:),eqtype_,endog_);
      [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
   else;     
      normInit=norm(Shocks);%updating
      ActIndicatorInit=ActIndicator;
   end;

end;

%Second, working on the foreign FFR shocks
Sperf = min(find(ActIndicator(:,2)==1));
Eperf = max(find(ActIndicator(:,2)==1));
IndVecFFRf=[Sperf:1:Eperf];
if isempty(IndVecFFRf)==0;
    ShocksF = ShockInfMat(size(ShocksD,1)+1:end,:);
end;

if any(ShocksF(:,1)<0);
   IndVec=find(ShocksF(:,1)<0);
   i=1;
   SuccessInf = [];%= zeros(length(IndVec),1);
   while length(IndVec)>=1 & i<=length(IndVec);
       ActIndicatorT(IndVec(i)+(Sperf-1),2)=0;
       [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
       [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
       if min(min(simvar(:,[1 2])+4))<-1e-5;%things did not work out. stop
          SuccessInf = [SuccessInf;0];
          ActIndicatorT(IndVec(i)+(Sperf-1),2)=1;
          if length(IndVec)>1;
             IndVec=IndVec(2:end);
          else;
             break
          end;
       else;%as for FFR, conjecture that all removed shocks do not cause other positive shocks to become negative
          SuccessInf = [SuccessInf;1];
          i=i+1;
       end;
   end;

   if mean(SuccessInf)==1;
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
      ActIndicator=ActIndicatorT;
      %disp('Success: We could remove all negative shocks for foreign FFR');
   elseif any(SuccessInf==1);%Some negative shock could be removed
      ActIndicator=ActIndicatorT;
      [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicator(1:t,:),eqtype_,endog_);
      [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
      %disp('Partial success: We could remove at least one of the negative shocks for foreign FFR');
   else; %disp('We could not remove any negative shocks for foreign FFR');
   end;
   if norm(Shocks)>normInit;%do not use updated shocks if mean value of shocks lowered
      ActIndicator=ActIndicatorInit;
      [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicator(1:t,:),eqtype_,endog_);
      [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
   end;
       
end;

%ActIndicator
%[Shocks ShockLoci]
%keyboard;