%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Program written to see if we can
%reduce out negative innovations
%so that max operator holds as far
%as possible
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp(' ');
disp('Checking if the solution appears is the preferred one, i.e. we cannot fulfill the ZLB with');
disp('a smaller set of innovations that have a smaller norm than what we have already');
disp(' ');

%ActIndicator
%[Shocks ShockLoci]

normInit=norm(Shocks);
%[norm(Init) norm(Shocks)]
ActIndicatorInit=ActIndicator;

ActIndicatorT=ActIndicator;%trial indicator matrix
ShockInfMat = [Shocks ShockLoci];
%First, working on the FFR shocks
Sper = min(find(ActIndicator(:,1)==1));
Eper = max(find(ActIndicator(:,1)==1));
IndVecFFR=[Sper:1:Eper];
if isempty(IndVecFFR)==0;
    ShocksD = ShockInfMat(IndVecFFR-(Sper-1),:);
end;
if any(ShocksD(:,1)<0);
   IndVec=find(ShocksD(:,1)<0);
   if min(IndVec)==1;%forward-pass
      i=1;
      Success = 1;
      while Success==1 & i+Sper<=Eper;
         ActIndicatorT(Sper+i-1,1)=0;
         [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
         [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         if min(min(simvar(:,[1 2])+4))<-1e-5;%things did not work out. stop
            Success=0;
            ActIndicatorT(Sper+i-1,1)=1;
            [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
            [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         else;%important, conjecture that other shocks do not flip sign if we can remove a negative shock, 
              %therefore, no need to verify that the other shocks have not flipped sign because we have removed a negative shock
            i=i+1;
         end;
      end;
   end;
   if max(IndVec)==length(ShocksD(:,1));%backward-pass
      i=1;
      Success = 1;
      while Success==1 & i+Sper<=Eper;
         ActIndicatorT(Eper-i+1,1)=0;
         [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
         [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         if min(min(simvar(:,[1 2])+4))<-1e-5;%things did not work out. stop
            Success=0;
            ActIndicatorT(Eper-i+1,1)=1;
            [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
            [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         else;%important, conjecture that other shocks do not flip sign if we can remove a negative shock, 
              %therefore, no need to verify that the other shocks have not flipped sign because we have removed a negative shock
            i=i+1;
         end;
      end;
   end;
   if norm(Shocks)>normInit;%do not use updated shocks if norm of shocks higher
      ActIndicator=ActIndicatorInit;
      [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicator(1:t,:),eqtype_,endog_);
      [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
   else;     
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
      normInit=norm(Shocks);%updating
      ActIndicatorInit=ActIndicator;
   end;
end;

%Second, working on the foreign FFR shocks
Sperf = min(find(ActIndicator(:,2)==1));
Eperf = max(find(ActIndicator(:,2)==1));
IndVecFFRf=[Sperf:1:Eperf];
if isempty(IndVecFFRf)==0;
    ShocksF = ShockInfMat(size(ShocksD,1)+1:end,:);
end;

if any(ShocksF(:,1)<0);
   IndVec=find(ShocksF(:,1)<0);
   if min(IndVec)==1;%forward-pass
      i=1;
      Success = 1;
      while Success==1 & i+Sperf<=Eperf;
         ActIndicatorT(Sperf+i-1,1)=0;
         [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
         [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         if min(min(simvar(:,[1 2])+4))<-1e-5;%things did not work out. stop
            Success=0;
            ActIndicatorT(Sperf+i-1,1)=1;
            [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
            [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         else;%important, conjecture that other shocks do not flip sign if we can remove a negative shock, 
              %therefore, no need to verify that the other shocks have not flipped sign because we have removed a negative shock
            i=i+1;
         end;
      end;
   end;
   if max(IndVec)==length(ShocksF(:,1));%backward-pass
      i=1;
      Success = 1;
      while Success==1 & i+Sperf<=Eperf;
         ActIndicatorT(Eperf-i+1,1)=0;
         [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
         [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         if min(min(simvar(:,[1 2])+4))<-1e-5;%things did not work out. stop
            Success=0;
            ActIndicatorT(Eperf-i+1,1)=1;
            [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicatorT(1:t,:),eqtype_,endog_);
            [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
         else;%important, conjecture that other shocks do not flip sign if we can remove a negative shock, 
              %therefore, no need to verify that the other shocks have not flipped sign because we have removed a negative shock
            i=i+1;
         end;
      end;
   end;
   if norm(Shocks)>normInit;%do not use updated shocks if norm of shocks higher
      ActIndicator=ActIndicatorInit;
      [Shocks,ShockLoci] = FindShocksAIM(cofb,scof,IrLoc,AltIntRatePath(1:t,:),ShockLoc,ActIndicator(1:t,:),eqtype_,endog_);
      [simvar,zzAIM] = SimulateModelAIM(cofb,scof,zzInit,[ShockSizeOS;Shocks],[ShockLocOS;ShockLoci],TT,eqtype_,endog_);
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
   else;     
      simvar(:,[1 2])=simvar(:,[1 2])+4*rbar*ones(TT,2);%adding mean to FFR
      simvar(:,[3 4])=simvar(:,[3 4])+400*(pibar-1)*ones(TT,2);%adding mean to inflation
      ModelProj  =[[4*rbar 4*rbar 400*(pibar-1) 400*(pibar-1) 0 0];simvar];
      subplot(2,1,1);plot([ModelProjOld(:,1) ModelProj(:,1)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      subplot(2,1,2);plot([ModelProjOld(:,2) ModelProj(:,2)]);pause(.2);%plotting interest rate forecast conditional on hitting the ZLB upto time t
      ModelProjOld=ModelProj;
      normInit=norm(Shocks);%updating
      ActIndicatorInit=ActIndicator;
   end;
end;
%ActIndicator
%[Shocks ShockLoci]
%keyboard;