function [Shocks,ShockLoc] = FindShocksAIM(cofb,scof,IrLoc,IRpath,ShockLoc,ActIndicator,eqtype_,endog_);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
%A program to find the anticipated policy interventions that produce a
%given interest rate path (IRpath).
%
%Modified by Jesper Lind 2009-03-19 so that it can handle both a
%domestic and foreign interest rate path.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Shocks = [];
   
nshk=length(find(eqtype_==0)); % # exogenous shocks
ntot=size(endog_,1);
nendog = ntot-nshk;
Amat = full(cofb);
bstar=inv(full(scof(:,ntot+1:2*ntot)));
Bmat=bstar(:,nendog+1:nendog+nshk);

T = size(IRpath,1);%number of periods to fix IR path
if size(IRpath,2)>1;
   T=2*T;
end;

% if T>length(ShockLoc);
%     error('You cannot match such a long interest rate sequence with this number of shocks, you need to add shocks in mod file')
% end;

%Setting up equation system for solution of shocks
RespMat = zeros(T,T);
if size(IRpath,2)==1;%condition on only one interest rate
   %RespMat(1,:) = Bmat(IrLoc,ShockLoc(1:T));
   for t=1:T;
       BtildeMat= Amat^(t-1) * Bmat;
       RespMat(t,:) = BtildeMat(IrLoc,ShockLoc(1:T));
   end;
   IndVec=find(ActIndicator==1);
   RespMat = RespMat(IndVec,IndVec);
   IRpath=IRpath(IndVec);
   Shocks=inv(RespMat)*IRpath;
   ShockLoc=ShockLoc(1)-1+IndVec;
   
else;%conditioning on multiple interest rate paths
    
   ShockLoc = vec(ShockLoc(:,1:T/2)')';%Vectorizing the 2 x nshocks matrix
   IRpath   = vec(IRpath);             %Vectorizing the 2 x nshocks matrix
   for t=1:T/2;
       BtildeMat= Amat^(t-1) * Bmat;
       RespMat(t,:)     = BtildeMat(IrLoc(1),ShockLoc(1:T));
       RespMat(t+T/2,:) = BtildeMat(IrLoc(2),ShockLoc(1:T));
   end;
   IndVec=find(ActIndicator==1);
   RespMat = RespMat(IndVec,IndVec);
   IRpath=IRpath(IndVec);
   Shocks=inv(RespMat)*IRpath;
   ShockLoc=ShockLoc(IndVec)';
      
end;




