%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Figure 7 of June 2014 final draft
% Shows responses to Monetary Policy Tightening (transient vs. persistent)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

T = 40;            %Number of periods to compute impulse
PlotInternal = 1;  %Set of variables to plot, 1 for internal variables, 0 for figures in paper
PlotInLevels = 1;  %if 1, then plot in level space where steady state values in MeanVec are used. If 0, then plot as deviations from SS
% 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Type and size of shocks to compute
%IRFs for
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

mu1 = .92;    % persistence of labor force participation rate 
mu3 = .071;   % sensitivity of LFP to unemployment 

jj = 5;  %picks out monetary shock in calc_impulses 

psip = .975;
chi = 4;

gam_dpq= 2;
gam_xgap= 0;
gam_egap = .25;
rho_m1 = .3;
std_mon = 0.4;
solv_searchn1a;
calc_impulses;
ytay = y1;

mperiods = 4;
%solv_searchn1a;
calc_impulses_sequence;
yalt1 = y1;

rho_m1 = .1;
std_mon = 0.4;
mperiods = 12;
solv_searchn1a;
calc_impulses_sequence;
yalt2 = 0.25*y1;



XGAPLoc   = strmatch('xgap',cellstr(endog_),'exact');%nendog;
DPQLoc    = strmatch('dpq',cellstr(endog_),'exact');%nendog;
RSLoc     = strmatch('rs',cellstr(endog_),'exact');%nendog;
RRLoc     = strmatch('rt',cellstr(endog_),'exact');%nendog;
RRPOTLoc  = strmatch('rt_pot',cellstr(endog_),'exact');%nendog;
BTARSHKLoc = strmatch('btarshk',cellstr(endog_),'exact');%nendog;
GOVSHKLoc = strmatch('govshk',cellstr(endog_),'exact');%nendog;
PMARKSHKLoc = strmatch('techshk',cellstr(endog_),'exact');%nendog;
MPSHKLoc  = strmatch('errffr0',cellstr(endog_),'exact');%nendog;
PQLoc   = strmatch('pq',cellstr(endog_),'exact');%nendog;
EGAPLoc   = strmatch('egap',cellstr(endog_),'exact');%nendog;
LFPGAPLoc   = strmatch('lfpgap',cellstr(endog_),'exact');%nendog;


%figure('PaperPosition',[0.25,0.25,8.0,10.5],'PaperOrientation','Portrait');

figure('PaperOrientation','Portrait');
TT = 1:20;
title = {'Figure 7:  Monetary Policy Tightening'};
subtitle = {'backward adjustment costs'};

subplot(2,1,1)
h1=plot(TT,(1/(1-alpha))*ytay(XGAPLoc,TT)',TT,ytay(LFPGAPLoc,TT)');
legend(h1,'Overall Employment Gap','Participation Gap','location','SouthEast');
set(h1,'linewidth',3,{'linestyle'},{'-';'--'});
text('String','Transient Tightening','Units','normalized', ...
     'Position',[0.5 1.05],...
     'FontSize',12,'FontWeight','bold','HorizontalAlignment','center');

set(gca,'XTick',[1:4:20])
set(gca,'XTickLabel','0|4|8|12|16')

subplot(2,1,2)
h2=plot(TT,(1/(1-alpha))*yalt2(XGAPLoc,TT)',TT,yalt2(LFPGAPLoc,TT)');
set(h2,'linewidth',3,{'linestyle'},{'-';'--'});
text('String','Persistent Tightening','Units','normalized', ...
     'Position',[0.5 1.05],...
     'FontSize',12,'FontWeight','bold','HorizontalAlignment','center');
set(gca,'XTick',[1:4:20])
set(gca,'XTickLabel','0|4|8|12|16')

%eval('print -depsc2 u:\modelm\searchm\figs\fig7.eps');


